unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, StdCtrls, ExtCtrls, Buttons, XPMan, Menus;

type
  TfrmMain = class(TForm)
    pnConfig: TPanel;
    cbPort: TComboBox;
    cbBaud: TComboBox;
    cbParity: TComboBox;
    btnOpen: TButton;
    pgMain: TPageControl;
    tsConfig: TTabSheet;
    tsPowerControll: TTabSheet;
    sgControl: TStringGrid;
    cbParity2: TComboBox;
    cbBaudRate: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    cbLocalMode: TCheckBox;
    cbClick: TCheckBox;
    cbPersist: TCheckBox;
    cbSoftMode: TCheckBox;
    edSoftTime: TEdit;
    Label3: TLabel;
    btnReadParam: TButton;
    btnSetParam: TButton;
    tmrScanState: TTimer;
    pmControl: TPopupMenu;
    miOnGroup: TMenuItem;
    miOffGroup: TMenuItem;
    edCode: TEdit;
    Label4: TLabel;
    tsState: TTabSheet;
    Label5: TLabel;
    cbLed0: TCheckBox;
    cbLed1: TCheckBox;
    cbLed2: TCheckBox;
    cbLed3: TCheckBox;
    cbLed4: TCheckBox;
    cbLed5: TCheckBox;
    cbLed6: TCheckBox;
    Label6: TLabel;
    cbStateLoadlMode: TCheckBox;
    sbControl: TStatusBar;
    XPManifest1: TXPManifest;
    procedure sgControlDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure tmrScanStateTimer(Sender: TObject);
    procedure sgControlDblClick(Sender: TObject);
    procedure miOnGroupClick(Sender: TObject);
    procedure miOffGroupClick(Sender: TObject);
    procedure btnReadParamClick(Sender: TObject);
    procedure btnSetParamClick(Sender: TObject);
    procedure OnPWRStateChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
Uses pwr;

{$R *.dfm}


procedure TfrmMain.sgControlDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
Var
	Chanel : Integer;
begin
	//      


	Chanel := Acol + Arow*8;

	sgControl.Canvas.Brush.Color := clWindow;
	sgControl.Canvas.Brush.Style := bsSolid;
	sgControl.Canvas.Pen.Color := clHighlight;

	if gdSelected in State Then sgControl.Canvas.Rectangle(Rect)
	else sgControl.Canvas.FillRect(Rect);

    sgControl.Canvas.Brush.Color := clMoneyGreen;
	If not pwrGetChanelState(Chanel) Then sgControl.Canvas.Brush.Style := bsClear;
	sgControl.Canvas.RoundRect(rect.Left+2, Rect.Top+2, rect.Right-2, Rect.Bottom-2,5,5);

	sgControl.Canvas.Brush.Style := bsClear;
	sgControl.Canvas.TextRect(Rect,Rect.Left+10, Rect.Top+4, IntToStr(Chanel));
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	//    
	DetectPorts(cbPort.Items);
	if cbPort.Items.Count <> 0 Then cbPort.ItemIndex := 0;  
end;

procedure TfrmMain.btnOpenClick(Sender: TObject);
begin
	//   
	if OpenPort(cbPort.Text, StrToInt(cbBaud.Text), cbParity.ItemIndex) Then Begin
		//        
		If not pwrReadChanels() Then Begin
			//    

			//  
			tmrScanState.Enabled := False;
			Exit;
        End;

		//   Grid   
		if ChanelCount = 0 Then Begin
			//   
			ShowMessage('PWR8 v2      !');
			pgMain.Enabled := False;
			tmrScanState.Enabled := False;
		End;

		sgControl.RowCount := ChanelCount div 8;
		sgControl.ColCount := 8;
		pgMain.Visible := True;
		tmrScanState.Enabled := True;
		sgControl.Repaint();
	End;
end;

procedure TfrmMain.tmrScanStateTimer(Sender: TObject);
Var
	State : TPWRState;
begin
	//  ,      
	case pgMain.ActivePageIndex of
		1:
		Begin
			//    
			If pwrReadChanels() Then Begin
				sgControl.Repaint;
				sbControl.SimpleText := ': OnLine';
			End else sbControl.SimpleText := ': OffLine';
		End;
		2:
		Begin
			//   
			if pwrGetState(State) Then Begin
				cbLed0.Checked := State.Leds and 1 <> 0;
				cbLed1.Checked := State.Leds and 2 <> 0;
				cbLed2.Checked := State.Leds and 4 <> 0;
				cbLed3.Checked := State.Leds and 8 <> 0;
				cbLed4.Checked := State.Leds and 16 <> 0;
				cbLed5.Checked := State.Leds and 32 <> 0;
				cbLed6.Checked := State.Leds and 64 <> 0;

				cbStateLoadlMode.Checked := State.Flags and FLG_STATE_LOCALMODE <> 0;
				sbControl.SimpleText := ': OnLine';
			End else sbControl.SimpleText := ': OffLine';
		End;
	End;
end;

procedure TfrmMain.sgControlDblClick(Sender: TObject);
Var
	Chanel : Integer;
begin
	// / 
	Chanel := sgControl.Col + sgControl.Row * 8;
    //     
	pwrBeginChanelUpdate();
	pwrSetChanelState(Chanel, not pwrGetChanelState(Chanel));
	if not pwrEndChanelUpdate() Then ShowMessage('   !');
end;

procedure TfrmMain.miOnGroupClick(Sender: TObject);
Var
	i, j : Integer;
begin
	//   
    pwrBeginChanelUpdate();
    For i := sgControl.Selection.Left to sgControl.Selection.Right do
		For j := sgControl.Selection.Top to sgControl.Selection.Bottom do
            pwrSetChanelState(i + j*8, True);
	if not pwrEndChanelUpdate() Then ShowMessage('   (-)!');
end;


procedure TfrmMain.miOffGroupClick(Sender: TObject);
Var
	i, j : Integer;
begin
	// 
    pwrBeginChanelUpdate();
    For i := sgControl.Selection.Left to sgControl.Selection.Right do
		For j := sgControl.Selection.Top to sgControl.Selection.Bottom do
            pwrSetChanelState(i + j*8, False);
	if not pwrEndChanelUpdate() Then ShowMessage('   (-)!');
end;

procedure TfrmMain.btnReadParamClick(Sender: TObject);
Var
	CommParam	: TPWRCommParam;
    PWRParam	: TPWRParam;
	i 			: integer;
begin
	//   
	if (not pwrGetCommParam(CommParam))or(not pwrGetParam(PWRParam)) Then Begin
		ShowMessage('  ');
		Exit;
	End;

	//      
    cbBaudRate.ItemIndex := CommParam.BaudRate;
	cbParity2.ItemIndex := CommParam.Parity;

	//  PWR 
	cbLocalMode.Checked	:= PWRParam.Flags and FLG_LOCALMODE <> 0;
	cbClick.Checked 	:= PWRParam.Flags and FLG_CLK_SOUND <> 0;
	cbPersist.Checked 	:= PWRParam.Flags and FLG_PERSIST <> 0;
	cbSoftMode.Checked 	:= PWRParam.Flags and FLG_SOFTCONTROL <> 0;

	edSoftTime.Text := IntToStr(PWRParam.SoftTime);
	edCode.Text := '';
	For i := 0 to 7 do if PWRParam.PassWord[i] = 0 then Break
	else edCode.Text := edCode.Text + Char($30 + PWRParam.PassWord[i]);
end;

procedure TfrmMain.btnSetParamClick(Sender: TObject);
Label
	Error;
Var
	CommParam	: TPWRCommParam;
    PWRParam	: TPWRParam;
	i 			: integer;
begin
	//   

	//  
	CommParam.BaudRate	:= cbBaudRate.ItemIndex;
	CommParam.Parity	:= cbParity2.ItemIndex;

	//  PWR 
	PWRParam.Flags := 0;
	if cbLocalMode.Checked	Then PWRParam.Flags := PWRParam.Flags or FLG_LOCALMODE;
	if cbClick.Checked		Then PWRParam.Flags := PWRParam.Flags or FLG_CLK_SOUND;
	if cbPersist.Checked	Then PWRParam.Flags := PWRParam.Flags or FLG_PERSIST;
	if cbSoftMode.Checked	Then PWRParam.Flags := PWRParam.Flags or FLG_SOFTCONTROL;

	PWRParam.SoftTime := StrToInt(edSoftTime.Text);
	FillChar(PWRParam.PassWord, 8, 0);
	if Length(edCode.Text) > 8 Then Begin
		ShowMessage('    !');
		Exit;
	End;

	For i := 1 to Length(edCode.Text) do
		PWRParam.PassWord[i-1] := StrToInt(edCode.Text[i]);


	//   
	If not pwrBlock() Then Goto Error;
	If not pwrSetCommParam(CommParam) Then Goto Error;
	If not pwrSetParam(PWRParam) Then Goto Error;
	If not pwrReset() Then Goto Error;

	//   
	tmrScanState.Enabled := False;
	pgMain.Visible := False;
	ClosePort();
	cbBaud.ItemIndex := cbBaudRate.ItemIndex;
	cbParity.ItemIndex := cbParity2.ItemIndex;
	Exit;
Error:
	ShowMessage('  ');
end;



procedure TfrmMain.OnPWRStateChange(Sender: TObject);
Var
	State : TPWRState;
begin
	//    
    //  
	State.Leds := 0;
	if cbLed0.Checked Then State.Leds := State.Leds or 1;
	if cbLed1.Checked Then State.Leds := State.Leds or 2;
	if cbLed2.Checked Then State.Leds := State.Leds or 4;
	if cbLed3.Checked Then State.Leds := State.Leds or 8;
	if cbLed4.Checked Then State.Leds := State.Leds or 16;
	if cbLed5.Checked Then State.Leds := State.Leds or 32;
	if cbLed6.Checked Then State.Leds := State.Leds or 64;

	State.Flags := 0;
	if cbStateLoadlMode.Checked Then State.Flags := State.Flags or FLG_STATE_LOCALMODE;

	if not pwrSetState(state) Then ShowMessage('    !');
end;

end.
